//+----------------------------------------------------------------------------+ 
//|                                   Aleksandr Pak, Alma-Ata, 03.2008         |
//|Expert Advisor GTerminal Graphical trading management,                      |
//|Half-automated. Breakout/pivot, upon parameters in the line name            |
//+----------------------------------------------------------------------------+

//********************************************************************************
/*




*/
//********************************************************************************


/*
Graphical trade management by request lines == graphical orders. 
Tried in real trading in Forex, CFD and in the visual mode of the strategy tester.
Commemnts about the EA operation are accepted in Forum.

Ver.2
Names if global variables are changed, now each EA version on different symbols remembers its orders avter switching of.

ADDED order closing upon delete of open line (see below).

*****
ADDED controling line PAUSE by remark of ForexTools:
Right thin = operation, left thick = PAUSE => all trade functions are not executed, not checked, except for 
already started ones. If a pause didn't become thick, but is already to the left, the pause has already occured.
(i.e. no need to wait until it becomes thick).
At uploading the EA sets a red PAUSE line to the right of market and automatically moves it further.

Manual shift of the PAUSE line to the bars to the lefy of zero bar prohibits the EA to sen orders.
 :   PAUSE    -      .
Pause doesn't prohibit being executed order sending.
Pause should be used in real/demo for security sace during manipulations  with graphical order lines.
*******

FIXED small errors.




Trade request lines, trade request = name + parameters
Order opening:
BuyStop     tp=x sl=x
BuyLimit    tp=x sl=x
SellStop    tp=x sl=x
SellLimit   tp=x sl=x
request name is separated by space, capital/lowercase letters are not differenciated
tp/sl parameters are placed in any order, can be absent, default=0
Only one order up/down can be opened
At switching off, account changing trade orders opene by EA are remembered in global variables.
At the repeated loading and at each tick tickets of supported accounts are checked. 
So you can delete/add manually your orders, delete manually EA orders, the EA sees, allows, but the only thing 
the EA can do with new orders placed manually - close them automatically by TpAll..., SlAll... lines 

Capital/lowercase letters are not differenciated.
Convenient to write with Caps/Lock on => BUYSTOP TP=100 SL=50

Lines-requests to close an order of the indicate type:
SlBuy
TpBuy
SlSell
TpSell
Now parameters. Are not deleted automatically.
Before palcing order open lines don't forget at what market side close lines are, 
otherwise can be closed immediately.

lines-requests to close all orders of the indicate type.
SlAllBuy
TpAllBuy
SlAllSell
TpAllSell
 Orders of other symbols, as well as pending orders are not closed.
Convenient to use for orders opened manually. 

Generally lines of graphical orders are equivalent to trailing (except for Internet connection failure).

GTerminal has adjustable operation bar: variable start - assigns a bar on which a line triggers.
By default - zero bar.

Term of line-request triggering is cross_method variable 

0-strict term of crossing Close[start] &  Close[start+1] of two bars, on different sides from the line
Graphical order triggers when price a sort of bites a line. 
I.e. in this condition graph. order doesn't always trigger, only when the line is "sticked" between Close 
of two bars.


1-mild crossing condition, (by default) on one bar Close[start] crossed the line.
Triggers always, actually the condition of the line being above/below Close of the zero (first, etc.) bar.
For example, 
Buystop, TpBuy, TpAllBuy, Selllimit, SlSell, SlAllSell will trigger at any line position below price.


Global variables of the terminal start with GT_, used to restor at computer turning off/failure.
GT_SELL_symbol
GT_Buy_symbol
Ticket number, the orders of which are managed by the EA.

Comments in white letters in upper left chart corner Buy=  Sell= are tickets of opened orders. 0 = no order. -1 =error occured
At a trade request sending a red text Open Buy Close ticket Close ALL appears above price for the whole time.

GTerminal does not control free margin, because it is half-automated.
If free margin is not enough, the EA continues operation. Error is detected at order sending.
When free margin is not enough, attempts to sen an order will be repeated, it is not controlled.

GTerminal is started on each tick. If no ticks the EA reacts slowly.
EA looping is possible, but then will work only on one chart.

GTerminal works in a strategy tester as a trainer. 
Working in strategy tester does not influence other EA copies.
To train pips-trading set BUYSTOP line in any place below price, SELLSTOP above price. 
Orders can be closed by deleting dashed lines.

For training in other strategies it is recommended to stop testing pressing ||/>> 
carry analysis, set graphical orders.


Lines of graphical orders are checked at each tick over again, that's why they may be moved, renamed, parameters may be changed.
If ticks come rarely, the waiting for changes in a chart=EA reaction will be observable.

Remember: Placing tp/sl in each order saves from accidents.

Good luck!!!
*/

#property copyright "Aleksandr Pak, Almaty,2008-ver2"
#property link "ekr-ap@mail.ru"
#property show_inputs
#include <WinUser32.mqh>

 extern double Lot=0.2;          //lot size
 extern int Slipp=6;             //Slippage
 extern int Pop=3;               //attempts to open order. 
 extern int cross_method=1;      //flag of price/line crossing calculation 0=strict on two bars,1 immediat. at one touch.
 extern int start=0;             //analysis start 0=zero bar, 1 = 1st bar, etc.
 extern color color_buy=Aqua;    //buy lines color
 extern color color_sell=Orange; //sell lines color


double price0, price1;
double Last_time;
int Buy_ticket,Sell_ticket;
int tp, sl;
int Pause=0;
double last_pause;
int t_first=0; //flag of the 1st tick
int glob_s=0, glob_b=0;

color color_tp_buy=Aqua, color_sl_buy=Aqua;
string BUY_global_name,SELL_global_name;
string message; //description of the last trading error
string last_line; //last line that is in operation
string Pause_name;

int init()
{double t;
               
         BUY_global_name=  "GT_BUY_"+  Symbol();
         SELL_global_name= "GT_SELL_"+ Symbol();
              
         if(!IsTesting())
         {  Buy_ticket = GlobalVariableGet(BUY_global_name);
            if(Buy_ticket!=0)
            {if(OrderSelect(Buy_ticket,SELECT_BY_TICKET)==TRUE) 
                       { t=OrderCloseTime();
                           if(t!=0) { Buy_ticket=0; GlobalVariableSet(BUY_global_name,0); }
                       }   else {Buy_ticket=0; GlobalVariableSet(BUY_global_name,0);}
            }
            
            Sell_ticket = GlobalVariableGet(SELL_global_name);
            if(Sell_ticket!=0)
            {if(OrderSelect(Sell_ticket,SELECT_BY_TICKET)==TRUE) 
                  {t=OrderCloseTime();
                           if(t!=0) { Sell_ticket=0; GlobalVariableSet(SELL_global_name,0); }
                  }        else {Sell_ticket=0;GlobalVariableSet(SELL_global_name,0);}
            }
          }
     ObjectCreate("PAUSE", OBJ_VLINE, 0,iTime(Symbol(),0,0)+12*60*Period(),0);
     ObjectSet("PAUSE",OBJPROP_WIDTH,1);
           ObjectSet("PAUSE",OBJPROP_COLOR,Red);             
    Comment("ticket buy="+DoubleToStr(Buy_ticket,0)+"  ticket sell="+DoubleToStr(Sell_ticket,0));        
return (0);
}


int deinit()
{
   ObjectDelete("PipsWork");
   return(0);
}

void start()
{  int i,j,k,Slipp,Pop,err,crach;
   double Lot,t;
   int ticket;
 
 
         t=iTime(Symbol(),0,0);
         if(t>Last_time){Last_time=t; t_first=1;}
 
  if(Buy_ticket!=0)
            {if(OrderSelect(Buy_ticket,SELECT_BY_TICKET)==TRUE) 
                       { t=OrderCloseTime();
                           if(t!=0) { Buy_ticket=0; glob_b=1;}
                      
                       }   else {Buy_ticket=0; glob_b=1;}
            }
  if(Sell_ticket!=0)
            {if(OrderSelect(Sell_ticket,SELECT_BY_TICKET)==TRUE) 
                  {t=OrderCloseTime();
                           if(t!=0) { Sell_ticket=0; glob_s=1; }
                  }        else {Sell_ticket=0; glob_s=1;}
            }
            
    if(!search_name_pause())
      {
     // Print("Work");
            
 //........................................................................................................
//.................detecting trade signals     
   
                  if(cross_up("buystop",color_buy))
                     {
                     if(Buy_ticket<=0)               
                        {  param(last_line); 
                           Buy_ticket=send_order(0,0,ticket,Lot,Slipp,Pop,tp,sl); //if order not open, ticket is negative
                              if(Buy_ticket>0) 
                                 {  
                                    fixline(last_line,Buy_ticket,color_buy);
                                    glob_b=1;
                                 } 
                        }
                     }                          
      //...................
                  if(cross_down("buylimit",color_buy))
                     {  
                     if(Buy_ticket<=0)           
                        {
                           param(last_line);
                           Buy_ticket=send_order(0,0,ticket,Lot,Slipp,Pop,tp,sl);
                           if(Buy_ticket>0) 
                           {
                              fixline(last_line,Buy_ticket,color_buy); 
                              glob_b=1;
                           }
                         }                      
                      }
      //...................      
                  if( cross_down("slbuy",color_buy))
                     {
                        if(close(Buy_ticket)==0)
                        {
                           Buy_ticket=0;
                           glob_b=1;
                        }
                      }
     //...................
                  if(cross_up("tpbuy",color_buy))
                      {
                      if(close(Buy_ticket)==0)
                        {
                           Buy_ticket=0;
                           glob_b=1;
                        }
                      }
     //...................
       if(cross_down( "slallbuy",color_buy )){ close_all(OP_BUY); Buy_ticket=0; glob_b=1;  }
                        
       if(cross_up  ( "tpallbuy",color_buy )){ close_all(OP_BUY); Buy_ticket=0; glob_b=1;  }   
  //************ 
       if( cross_down("sellstop",color_sell))
                 {
                     if(Sell_ticket<=0)
                        {
                              param(last_line);
                              Sell_ticket=send_order(1,0,ticket,Lot,Slipp,Pop,tp,sl);
                              if(Sell_ticket>0) { glob_s=1; fixline(last_line,Sell_ticket,color_sell); }
                        }
                  }  
      //...................
       if(cross_up("selllimit",color_sell))
                     {
                        if(Sell_ticket<=0)
                           {
                              param(last_line);
                              Sell_ticket=send_order(1,0,ticket,Lot,Slipp,Pop,tp,sl); 
                              if(Sell_ticket>0) { glob_s=1; fixline(last_line,Sell_ticket,color_sell); } 
                            }    
                     }
                    
      //...................    
      if(cross_up("slsell",color_sell))
           {
           if(Sell_ticket!=0) { if(close(Sell_ticket)==0) {Sell_ticket=0; glob_s=1; } }
           }                 
  //**************/                 
      if(cross_down("tpsell",color_sell))
          {
          if(Sell_ticket!=0) { if(close(Sell_ticket)==0){Sell_ticket=0; glob_s=1; } }
          }
      //.......................                                         
      if(cross_up( "slallsell",color_sell)) {close_all(OP_SELL); Sell_ticket=0; glob_s=1; }
      //...........................
      if(cross_down( "tpallsell",color_sell)) {close_all(OP_SELL); Sell_ticket=0; glob_s=1; }                                                                                        
//...................................................          
   
   } //pause
   
     else{/*Print("Pause");*/}
   
   SearchWorkLine();
   if(!IsTesting())
   {if(glob_b==1){glob_b=0; GlobalVariableSet(BUY_global_name,  Buy_ticket);}
    if(glob_s==1){glob_s=0; GlobalVariableSet(SELL_global_name, Sell_ticket);}  
   }
   t_first=0; //clear flag of 1st tick
   Comment("ticket buy="+DoubleToStr(Buy_ticket,0)+"  ticket sell="+DoubleToStr(Sell_ticket,0));
   ObjectDelete("PipsWork");
}

//******************************************************************************************

bool search_name_pause()
{double p,p2,t,t2,y; int error,i; string n;
         i=search_name_obj("paus");
         if (i>=0)
         {
            p=   ObjectGet(Pause_name,OBJPROP_TIME1); 
            p2=iTime(NULL,0,0); //zero bar time
     
            if(p-p2<0) //if to the left of zero bar
               { 
               
               if(last_pause==p&&Pause==0) //if weren't moved rammed into price
               {
                y=p2+12*60*Period();
                        for(i=0;i<10;i++)
                        {
                        ObjectSet(Pause_name,OBJPROP_TIME1,y);
                        WindowRedraw();
                        if(GetLastError()==0) break;
                        Sleep(100);
                        }
                       
                        last_pause=   y;
                        return(FALSE);
               
               }
                else
                {
                  Pause=1;
                  ObjectSet(Pause_name,OBJPROP_WIDTH,4);
                  WindowRedraw();
                  last_pause=p;
               return(TRUE); 
               }
               } else  {
                        
                        ObjectSet(Pause_name,OBJPROP_WIDTH,1);
                        if(t_first==1)
                              {
                              ObjectSet(Pause_name,OBJPROP_TIME1,ObjectGet(Pause_name,OBJPROP_TIME1)+Period()*60);
                              }
                        Pause=0;
                        WindowRedraw();
                        last_pause=ObjectGet(Pause_name,OBJPROP_TIME1); 
                        return(FALSE);
                        }
         
         }
 
}

//.........................
int search_name_obj(string c) //search through object list named starting from 'c' returns number in the list
{int i,k; string s;
   k=ObjectsTotal(); 
   for(i=k-1;i>=0;i--)  //can be quicker if all object names are stored in an array
   {  
      s=lowercaps(ObjectName(i));
    if (StringFind(s,c,0)>=0){ Pause_name=ObjectName(i); return(i);} 
   }
return (-1);
}

//............................

double first_line(string s,color col)  
{     int i; 
      string c,r;
      double p=100000000000,p2,rline,rp;
      int k=ObjectsTotal(); 

      for(i=k-1;i>=0;i--)
      {  
         c=ObjectName(i);
         r=search_left(c," ");
            if(r==s)
               {  p2 = ObjectGetValueByShift (c,start);
                  rline = NormalizeDouble (p2, Digits);
                  if(MathAbs(rline-price0)<p) {p=rline-price0; rp=rline; last_line=c;}
                  ObjectSet(c,OBJPROP_COLOR,col); 
               }
    }
   return (rp);
}

//....................................................

int fixline(string _name, int _B,color _color)
{int error;

string             txn="TICKET="+DoubleToStr(_B,0)+" "+_name+" DATE="+TimeToStr(TimeLocal(),
                   TIME_DATE)+" TIME="+TimeToStr(TimeLocal(),TIME_SECONDS);
                   
                   ObjectCreate(txn,OBJ_TREND,0,
                   ObjectGet( _name,OBJPROP_TIME1),ObjectGet( _name,OBJPROP_PRICE1),
                   ObjectGet( _name,OBJPROP_TIME2),ObjectGet( _name,OBJPROP_PRICE2));
                   while(TRUE)
                   {
                     ObjectDelete(_name); 
                     WindowRedraw();
                     if(ObjectFind(_name)==-1) break;
                   }
                   ObjectSet(txn,OBJPROP_STYLE,STYLE_DOT);
                   ObjectSet(txn,OBJPROP_COLOR,_color);
                  
}
//..........................................

int close_all(int typs)
  {
   bool   result;
   double price;
   int    cmd,error,i=0,k;
  
   double t;
   int ticket;
   string tr;
//----

  if(typs==0) tr="CLOSE ALL BUY"; else tr="CLOSE ALL SELL";
   k=OrdersTotal();
   for(i=k-1;i>=0;i--)
   {   
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) 
      {
         cmd=OrderType();
         t=OrderCloseTime();
         if((cmd==typs)&&Symbol()==OrderSymbol()&&t==0) 
         { 
               t=OrderOpenTime();
               if(t!=0)
                  { 
                     ObjectCreate("PipsWork",OBJ_TEXT,0,iTime(NULL,0,10),High[10]);
                     ObjectSetText("PipsWork", tr, 14,"",Red);
                     WindowRedraw();
                     close_(cmd); /* Sleep(500);*/
                    // Print("Exited close");
                   }              
               } 
      }  
         else {/*Print("Errorof position choosing=",i);*/}     
  }     
  
ObjectDelete("PipsWork");
   return(0);
  }
//.............................

int close_(int cmd)
{
   bool   result;
   double price;
   int    error,i=0;         
                  while(true)
                  {i+=1;
                   RefreshRates();
                  if(cmd==OP_BUY)      price=Bid; //window price, i.e. closes only on the order chart
                        else           price=Ask;
                        result=OrderClose(OrderTicket(),OrderLots(),price,12,CLR_NONE);
                        error=GetLastError(); 
                        if(result==TRUE) error=0; 
                        if(error!=0) {Sleep(3000); RefreshRates();} //when closing 6 attampts
                  else break;
                  if(i>6)break; ///6 attempts to close an order
                 }
return (error);
}

//......................
int close(int ticket)
  {
   bool   result;
   double price;
   int    cmd,error=-1,i=0;
   double t;
   string tr="CLOSE " + DoubleToStr(ticket,0);
 
 
   if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
      {
      cmd=OrderType();
    // Print(" ticket=",OrderTicket()," position=",i,"type=",cmd,"symbol=",Symbol()," ordersymbol=",OrderSymbol()," closetime=",OrderCloseTime());
       t=OrderCloseTime();
       if(Symbol()==OrderSymbol()&&t==0) { 
       ObjectCreate("PipsWork",OBJ_TEXT,0,iTime(NULL,0,10),High[10]);
       ObjectSetText("PipsWork", tr, 14,"",Red);
       WindowRedraw();

       error=close_(cmd); /* Sleep(500);*/
       
       } 
      }  else {/*Print("Error of position choosing=",i);*/}     
    
  
ObjectDelete("PipsWork");
   return(error);
  }

//..............................................................

int send_order(int teg_b,int sm, int ticket, double Lot, int Slipp, int Pop,int _tp, int _sl)
{int err=1,k=0,crach;
 double loss,profit;
 bool result=TRUE;
 string tr;
 if(teg_b==0) tr="OPEN BUY"; else tr="OPEN SELL";
 ObjectCreate("PipsWork",OBJ_TEXT,0,iTime(NULL,0,10),High[10]);
 ObjectSetText("PipsWork", tr, 14,"",Red);
 WindowRedraw();
       
       while(TRUE)
         { k+=1; RefreshRates(); 
                  double ask=NormalizeDouble(Ask,Digits),bid=NormalizeDouble(Bid,Digits);
              
                  if(Lot==0) Lot=0.1;
                  if(teg_b==0)
                  {
                  if (_sl>0) loss  =ask-_sl*Point;  else loss=0;
                  if (_tp>0) profit=ask+_tp*Point;    else profit=0;
                  if(sm==0) ticket=OrderSend(Symbol(),OP_BUY,Lot,ask,Slipp,loss,profit,NULL,0,0,CLR_NONE);                       
                                                else  result=OrderModify(ticket,0,loss,profit,0,CLR_NONE);                
                  } else
                     {
                     if (_sl>0) loss  =bid+_sl*Point;  else loss=0;
                     if (_tp>0) profit=bid-_tp*Point;    else profit=0;
                     if(sm==0) ticket=OrderSend(Symbol(),OP_SELL,Lot,bid,Slipp,loss,profit,NULL,0,0,CLR_NONE);                       
                                                else      result=OrderModify(ticket,0,loss,profit,0,CLR_NONE);               
                     }
         err=ShowError(Pop,k);
         if(err<=1&&result==TRUE) break; else  Sleep(3000); 
         if(k>=Pop) break;
         if(err==4||err==6||err==128||err==135||err==137||err==138||err==146) crach=0; else crach=1;
         if(crach==1) break;  //No new repeat is are crazy  
         
         }

 return (ticket);
}
//....................................................

string search_right(string s, string c)
{ int i,j,k,len; string r="",p;    
         i=StringFind(s,c,i); 
         if(i!=-1) 
         {i+=StringLen(c);
         r=""; len =StringLen(s);
   for(j=0;j<len;j++) { k=StringGetChar(s,i+j); if(k<=57&&k>=48||k==46||k==44) 
                                                {  p=StringSubstr(s,i+j,1); r=r+p;
                                                } else 
                break;}
          }
   return(r);
}

//..............

string search_left(string s,string c) 
{ int i,j,k,len; string r="",p;    
         i=StringFind(s,c,0);  
  if(i!=-1)
  {
  r="";        len =StringLen(s);
  r=StringSubstr(s,0,i);
  }
  else r=s;
  r=lowercaps(r);
  return(r);
}
//.........................
string lowercaps(string s)
{int i,k,c; string r=""; k=StringLen(s); for(i=0;i<k;i++){c=StringGetChar(s,i); if(c<91&&c>64) c+=32;r=r+CharToStr(c);}
 return (r);
}
//..........................

void param(string s)
      {string b,r;
         r=lowercaps(s);
         b=search_right(r,"tp="); if(StringLen(b)>0) tp =NormalizeDouble(StrToDouble(b),0); else tp=0;
         b=search_right(r,"sl="); if(StringLen(b)>0) sl =NormalizeDouble(StrToDouble(b),0); else sl=0;
        
         ObjectSetText(s,"profit="+DoubleToStr(tp,0)+"  "+"stoploss="+DoubleToStr(sl,0));
      }
//.....................................................................

int SearchWorkLine() //checking presence and line marking must correspond to working part
{int i,k,ti=0,ct,mt[100]; string r,c;
   k=ObjectsTotal(); //object numbers start from zero!!! Up to k-1!!!
   for(i=k-1;i>=0;i--)
   {  
      c=ObjectName(i);
      r=search_left(c," ");
      if(r==   "buylimit"  )  { param(c); ObjectSet(c,OBJPROP_COLOR,color_buy);}
      if(r==   "buystop"   )  { param(c); ObjectSet(c,OBJPROP_COLOR,color_buy);}
      if(r==   "tpbuy"     )  { ObjectSetText(c,"O.k."); ObjectSet(c,OBJPROP_COLOR,color_buy);}
      if(r==   "slbuy"     )  { ObjectSetText(c,"O.k."); ObjectSet(c,OBJPROP_COLOR,color_buy);}
      if(r==   "selllimit" )  { param(c); ObjectSet(c,OBJPROP_COLOR,color_sell);}
      if(r==   "sellstop"  )  { param(c); ObjectSet(c,OBJPROP_COLOR,color_sell);}
      if(r==   "tpsell"    )  { ObjectSetText(c,"O.k."); ObjectSet(c,OBJPROP_COLOR,color_sell);}
      if(r==   "slsell"    )  { ObjectSetText(c,"O.k."); ObjectSet(c,OBJPROP_COLOR,color_sell);}
      if(r==   "slallsell" )  { ObjectSetText(c,"O.k."); ObjectSet(c,OBJPROP_COLOR,color_sell);}
      if(r==   "tpallsell" )  { ObjectSetText(c,"O.k."); ObjectSet(c,OBJPROP_COLOR,color_sell);}
      if(r==   "slallbuy"  )  { ObjectSetText(c,"O.k."); ObjectSet(c,OBJPROP_COLOR,color_buy);}
      if(r==   "tpallbuy"  )  { ObjectSetText(c,"O.k."); ObjectSet(c,OBJPROP_COLOR,color_buy);}
      
      r=search_left(c,"=");
      if(r==   "ticket"    )  { ti=StrToDouble(search_right(c,"TICKET=")); 
                                  if(qwest_order(ti)>0) { ObjectDelete(c);} //clearing already closed
                              mt[ct]=ti; ct+=1; //marking dashed lines
                              
                              }  //if closed, delete dashed line
   }
   
      int t_w;
      if(Buy_ticket!=0) 
      {t_w=0;
         for(i=0;i<ct;i++)
            {if(Buy_ticket==mt[i]) t_w=1; }
         if(t_w==0){if(close(Buy_ticket)==0){Buy_ticket=0; glob_b=1;}}
      }
      
      if(Sell_ticket!=0) 
      {t_w=0;
         for(i=0;i<ct;i++)
            {if(Sell_ticket==mt[i]) t_w=1; }
         if(t_w==0){if(close(Sell_ticket)==0){Sell_ticket=0; glob_s=1;}}
      }



return (0);
}
//...............................
int qwest_order(int ticket) //if not closed 0, if closed 1 absent 2
{ 
 if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
         {
            double  t=OrderCloseTime();
            if(t==0) return (0); else return(1);
         }  else return (0);
}


//**************    
bool cross_down(string s, color col)
{double rline;
      rline=first_line(s, col);
      RefreshRates();
      price0=NormalizeDouble(Close[start],Digits);
      price1=NormalizeDouble(Close[start+1],Digits);
                 if(rline!=0) 
                 {                
                 if(cross_method==0) {if(rline>price0 && rline<price1) return (TRUE); else return(FALSE); }
                 if(cross_method==1) {if(rline>price0 ) return (TRUE); else return(FALSE); }
                 }
}


bool cross_up(string s, color col)
{  
double rline;
      rline=first_line(s, col);
      RefreshRates();
      price0=NormalizeDouble(Close[start],Digits);
      price1=NormalizeDouble(Close[start+1],Digits);
       if(rline!=0)
       {
       if(cross_method==0) {if(rline<price0&&rline>price1) return (TRUE); else return(FALSE); }
       if(cross_method==1) {if(rline<price0) return (TRUE); else return(FALSE); }
       } else return (FALSE);
}
//


int ShowError(int Pop, int k)
{
   string d_error;
   int err=GetLastError(),crach; //3 129 130 131 134 139 140 
   switch (err)            //retry only if 4, 6, 135, 136 137 138 146 
   {
      case   0: return;
      case   1: d_error="Unknown result"; break;
      case   2: d_error="Common error"; break;
      case   3: d_error="Invalid trade parameters"; break;
      case   4: d_error="Trade server is busy"; break;
      case   5: d_error="Old version of the client terminal"; break;
      case   6: d_error="No connection with trade server"; break;
      case   7: d_error="Not enough rights"; break;
      case   8: d_error="Too frequent requests"; break;
      case   9: d_error="Not allowed operation harming the server"; break;
      case  64: d_error="Account blocked"; break;
      case  65: d_error="Invalid account number"; break;
      case 128: d_error="Trade timeout"; break;
      case 129: d_error="Invalid price"; break;
      case 130: d_error="Invalid stops"; break;
      case 131: d_error="Invalid volume; break;
      case 132: d_error="Market is closed"; break;
      case 133: d_error="Trade is disabled"; break;
      case 134: d_error="Not enough money"; break;
      case 135: d_error="Price changed"; break;
      case 136: d_error="Off quotes"; break;
      case 137: d_error="Broker is busy"; break;
      case 138: d_error="Requote"; break;
      case 139: d_error="Order is locked"; break;
      case 140: d_error="long positions only allowed"; break;
      case 141: d_error="Too many requests"; break;
      case 145: d_error="Modification denied because an order is too close to market"; break;
      case 146: d_error="Trade context is busy"; break;
      case 147: d_error="Expirations are denied by broker"; break;
      default : d_error="Unknown error"; break;
   }
   
   if(err==4||err==6||err==128||err==135||err==137||err==138||err==146) crach=0; else crach=1; 
   string field="     ";
   string msg="Error #"+err+" "+d_error+field+ "Attempts="+DoubleToStr(k,0)+"  "+DoubleToStr(Pop,0);
   string title="Error"; if (AccountNumber()>0)title=AccountNumber()+": "+title;
  
                  ObjectSetText("PipsWork", msg, 14,"",Red); 
     if(Pop-1==k) ObjectSetText("PipsWork", msg, 14,"",Red); 
   message = msg;
   return (err);
}
//O.k.